;8/13/02 - fixed a spot that was missing the asmhighd()-type addressing
;7/29/02 - rewrote detection, now picks up "AsmPrgm" untokenized,
;  more specific about ignoring modules

;asm datatype for YAS 2.0
;by Aaron Curtis and Jonah Cohen

#define asmhighc(x) $f400+x-asm_comment
#define asmhighi(x) $f400+x-asm_icon
#define asmhighd(x) $f400+x-asm_detect
#define asmrelptr(x) x-$-1			;relative pointer

	.db 1							;low-ish priority
	.db $12							;detects programs
	.db "asm"						;3 byte descripiton

	.dw _exec_assembly

	.dw asm_enddetect-asm_detect
	.dw asmrelptr(asm_detect)

	.dw asm_endcomment-asm_comment
	.dw asmrelptr(asm_comment)

	.dw asm_endicon-asm_icon
	.dw asmrelptr(asm_icon)



asm_detect:
	call asmhighd(asm_detcode)
	ld a,$d
	out (5),a
	ret

asm_detcode:
	;z if asm
	call _load_ram_ahl
	out (5),a
	inc a
	out (6),a
	ld bc,-$4000+2
	add hl,bc
	
	ld de,asmhighd(asm_asmprgm)
	ld a,(hl)
	inc hl
	or a						;0 is untokenized
	call z,asmhighd(asm_checkstring)		;if untokenized, "AsmPrgm" is asm
	ccf
	ret nc

	cp $8e						;if tokenized, $8e27 and $8e28 are asm
	scf
	ret nz
	ld a,(hl)
	sub $27
	ret z
	dec a
	scf
	ret nz

	inc hl						;if $8e28, "bit 2, (iy+$1f) \ jp z,$416c"
								;should be ignored
	ld de,asmhighd(asm_modbytes)

asm_checkstring:
	;hl->string1
	;de->string2
	;c if strings match
	
	ld b,4		;7
asm_checkstringloop
	ld a,(de)
	xor (hl)
	ld a,b
	ret nz
	inc hl
	inc de
	djnz asm_checkstringloop
	scf
	ret

asm_asmprgm:
	.db "AsmP"		;rgm"
asm_modbytes:
	.db $fd,$cb,$1f,$56		;,$ca,$6c,$41
asm_enddetect:


asm_comment:
	in a,(6)
	out (5),a
	inc a
	out (6),a
	ld de,-$4000+2				;+2 to skip the asm token
	add hl,de
	ld c,l
	ld b,h

	ld a,(hl)					;check for nop / jp
	or a
	jr nz,asm_nocomment
	inc hl
	ld a,(hl)
	cp $c3
	jr nz,asm_nocomment

	ld de,5						;get the comment pointer
	add hl,de
	call $0033					;ld hl,(hl) ; a=h
	or l						;return if they used a .dw 0
	jr z,asm_nocomment
	ld de,$10000-_asm_exec_ram	;negative _asm_exec_ram
	add hl,de
	add hl,bc

	ld de,$f500					;copy comment to somewhere else...
	push de
copycomment:
		ld a,(hl)
		ldi
		or a
		jr nz,copycomment
	pop hl
	jr asm_commentfound

asm_nocomment:
	scf
asm_commentfound:
	ld a,$0d					;can't forget this :)
	out (5),a
	jp _ram_page_1
asm_endcomment:


asm_icon:
	in a,(6)
	out (5),a
	inc a
	out (6),a
	ld de,-$4000+2
	add hl,de
	ld c,l
	ld b,h

	ld a,(hl)
	or a
	jr nz,asm_defaulticon
	inc hl
	ld a,(hl)
	cp $c3
	jr nz,asm_defaulticon

	inc hl
	inc hl
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	inc hl
	inc hl
	push hl
		ld hl,-$0001			;$0001 = minimum version number for icons
		add hl,de
	pop hl
	jr nc,asm_defaulticon

	call $0033
	or l
	jr z,asm_defaulticon
	ld de,$10000-_asm_exec_ram	;negative _asm_exec_ram
	add hl,de
	add hl,bc

asm_loadicon:	
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld de,$f500
	push de
	push bc
	xor a
asm_iconcount:
		add a,c
		djnz asm_iconcount

asm_iconcopy:
		ldi
		dec a
		jr nz,asm_iconcopy
	pop bc
	pop hl

	ld a,$0d
	out (5),a
	jp _ram_page_1

asm_defaulticon:
    ld hl,asmhighi(asm_default_icon)
    jr asm_loadicon

asm_default_icon:
.db 6,1
.db %10000000
.db %01100000
.db %00110000
.db %00011100
.db %00011010
.db %00001110
asm_endicon:

.end
