#include asm86.inc
#include ram86.inc
#include hook.inc
#include flag86.inc
#define NOGROUP
#define NOWRITEBACK
#define NOINFO
#define NOREFRESH

.org _asm_exec_ram

	nop
	jp start
	.dw 2
commentptr:
	.dw comment
	.dw 0
	.dw datatypes

comment:
	.db "YAS in hook-form",0	

start:
	bit ex_asm_module,(iy+anumeditflgs)
	res ex_asm_module,(iy+anumeditflgs)
	jr nz,exec_as_module

	;*******************************
	;** install/remove parse hook **
	;*******************************

	ld hl,_sqrtparse					;"(sqrt)parse"
	rst 20h
	rst 10h								;does it exist already?
	jr c,install

	call _delvar						;if yes, delete it...
	;res alt_parse,(iy+exceptionFlg2)	;and tell the os to turn it off
	ld hl,removedmessage
	jr theend

install:	
	ld hl,codeend-code			;if it doesn't exist, create it
	call _CREATEPROG
	ret c						;leave if out of memory
	ex de,hl
	ld a,b
	call _load_ram_ahl			;get the address of the program in memory
	out (5),a					;in case it's split across 2 pages...
	inc a
	out (6),a
	ld de,-$4000+2
	add hl,de
	ex de,hl
	ld hl,altcode				;copy some code to the program
	ld bc,codeend-code
	ldir
	set alt_parse,(iy+exceptionFlg2)
	ld a,$d						;can't forget this :)
	out (5),a
	ld hl,installedmessage
theend:
	call _puts
	jp _newline

removedmessage:
	.db "Parse hook removed",0
installedmessage:
	.db "Parse hook installed",0
	

	;********************************************
	;** when called by (sqrt)parse, do this... **
	;********************************************

exec_as_module:
	call yas_initialize			;build datatype table
	ret c						;ret if there were none
	ld hl,(256*'#')+1			;open up the "#" program
	ld (_OP1+1),hl
	rst 10h
	ret c
	ex de,hl
	ld a,b
	call _inc_ptr_ahl			;first 2 bytes are program length
								; but we need a name-1
	call _abs_mov10toop1		;get the command line in OP1
	ld hl,_OP1+1
	ld a,(hl)
	sub $32						;$33-$3a are variable name tokens
								; where the first byte is the name
								; length+$32
	ret c
	ret z						;so leave if the token wasn't for var name
	cp 9
	ret nc
	ld (hl),a
	rst 10h						;open up the variable being parsed...
	ret c						;this check actually fails sometimes
								; when the var exists, why?
	ex de,hl					;put the vat address in de
	call yt_filesearch			;see if yas can execute this variable
								;(this is the main part of yas_get)
	call yas_stdports
	ret c
	xor a						;signal to stop parsing after this 
	ld (_alt_ret_status),a
	res alt_parse,(iy+exceptionFlg2)	;_parseinp calls sqrtparse if this is set
										;(that's bad)
	ld hl,prog_space
	push hl
	call yas_store
	pop hl
	jp yas_execute

#include yas.asm




datatypes:
	.db 3
	.dw asmdt
	.dw iondt
	.dw picdt
	;basdt would be rather pointless...

asmdt:
#include asm_dt_info.asm
iondt:
#include ion_dt_info.asm
picdt:
#include pic_dt_info.asm


	;*******************************************
	;** code to go in the (sqrt)parse program **
	;*******************************************

altcode:
	.org _asm_exec_ram-2
code:
	.db $8e,$28					;asm program token

	ld a,$11					;signal to parse normally
	ld (_alt_ret_status),a

	ld hl,(_asm_reg_hl)			;holds the correct _alt_ret_jmp_addr
	push hl

	;call hookyas as a module, that way (sqrt)parse doesn't
	;take up an extra 800 bytes...
	set ex_asm_module,(iy+anumeditflgs)
	ld hl,progname-1
	rst 20h
	rst 10h
	call nc,_exec_assembly		;this can change _alt_ret_status

	set alt_parse,(iy+exceptionFlg2)

	ld a,3
	ld (_alt_ret_jmp_page),a
	pop hl
	ld (_alt_ret_jmp_addr),hl
	ret

progname:
	.db 7,"hookyas"
codeend:


.end
 